/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef PARSERREGISTRATION_H
#define PARSERREGISTRATION_H

#include "MIDI_lib.h"
#include "Rogus_McBogus.h"

class ParserRegistration {
public:
	typedef parser* (*ParserFunc)(Rogus_McBogus*);
private:
	ParserFunc func;
	const char* name;
	ParserRegistration* next;
	static ParserRegistration* first;
	static void insert(ParserRegistration**, ParserRegistration*);
public:
	ParserRegistration(ParserFunc, const char* n);
	static int getNumParsers();
	static const char* getParserName(int);
	static ParserFunc getParserFunc(int);
};

#endif
// Author: Patrick Pelletier
