/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

// This parser, unlike a normal Rogus parser, doesn't actually do any
// MIDI I/O. It simply lists the input and output nodes present in the
// system. May be useful for diagnostics, or if you're curious.

#include "Rogus_McBogus.h"
#include "ParserRegistration.h"


class WhatNodesParser : public parser
{
   MIDIsvc* oap;
public:
	WhatNodesParser(Rogus_McBogus *r);
};

WhatNodesParser::
WhatNodesParser(Rogus_McBogus *r)
{
   oap = &r->o;

   ioref i;
	r->tw.pr("\nOutput Nodes:\n");
	for (i = 0; i < oap->howManyOutputNodes(); i++)
		r->tw.pr("  %s\n",oap->getOutputNodeName(i));

	r->tw.pr("\nInput Nodes:\n");
	for (i = 0; i < oap->howManyInputNodes(); i++)
		r->tw.pr("  %s\n",oap->getInputNodeName(i));

	r->tw.pr("\n");
}

static parser* newFunc(Rogus_McBogus *r)
{
	return (new WhatNodesParser(r));
}

static ParserRegistration reg(newFunc, "WhatNodesParser");

// Author: Patrick Pelletier
