/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef STATE_H
#define STATE_H

#include "Score.h"
#include "ChannelState.h"

class State : public PerChannel<ChannelStatePtr> {
	static ChannelState defaultChannelState;

public:
   struct my_struct {
	   const State* s;
	   void (*outfunc)(const MIDI_msg&);
	   ChannelState* dcs;
   };

  typedef UtilPtr<ChannelState> ChannelStatePtr;
  State(Score::ChannelUseMapPtr, ioref non);
  void update(const MIDI_msg*);
  void change(const State*, void (*outfunc)(const MIDI_msg&));
};

#endif
// Author: Patrick Pelletier
