/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef STATISTIC_H
#define STATISTIC_H

#include <stdio.h>
#include "err_and_warn.h"

class Statistic {
	Statistic* prev;
	Statistic* next;
	static Statistic* first;
public:
	Statistic();
	virtual ~Statistic();
	virtual void clear() = 0;
	virtual void stat(FILE*) = 0;
	static void reset(const char*);
	static void report(const char *version, err_and_warn*);
};

#endif
// Author: Patrick Pelletier
