/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef TRACKMERGER_H
#define TRACKMERGER_H

#include "UtilPtr.h"
#include "UtilArray.h"

template <class T>
class TrackMerger {
public:
	typedef UtilArray<T>                TrackRep;
	typedef UtilPtr  <TrackRep>         TrackRepPtr;
	typedef UtilArray<TrackRepPtr>      TrackRepPtrArray;
	typedef UtilPtr  <TrackRepPtrArray> TrackRepPtrArrayPtr;
	static TrackRepPtr merge(TrackRepPtrArrayPtr x)
	{
//		tw.spr("x->length = %d\r",x->length);
		if (x->length == 0)
			return new TrackRep(0);
		UINT sz = 0;
		UINT i;
		for (i = 0; i < x->length; i++)
		{
//			tw.spr("sz = %d, i = %d, (*x)[i]->length = %d\r",sz, i, (*x)[i]->length);
			sz += (*x)[i]->length;
//			tw.spr("sz = %d now\r",sz);
		}
//		tw.spr("sz = %d\r",sz);
		TrackRepPtr result = new TrackRep(sz);
		UtilArray<UINT> positions(x->length);
		for (i = 0; i < x->length; i++)
			positions[i] = 0;
		i = 0;
		while (i < sz)
		{
			long smallest = -1;
			int t = -1;
			for (UINT j = 0; j < x->length; j++)
				if ((positions[j] < (*x)[j]->length) && (t == -1 || (*((*x)[j]))[positions[j]].time < smallest))
				{
					t = j;
					smallest = (*((*x)[j]))[positions[j]].time;
				}
			(*result)[i] = (*((*x)[t]))[positions[t]];
			positions[t]++;
			i++;
		}
		return result;		
  	}
};

#endif
// Author: Patrick Pelletier
