#include <stdio.h>
#include <stdlib.h>
#include "err_and_warn.h"

void
err_and_warn::
helper(text_win::msgt msg_type, const char* format, ...)
{
	va_list ap;
	va_start(ap,format);
	twp->vpr(format, ap, msg_type);
	va_end(ap);
}

void
err_and_warn::
e( const char *format, ... )
{
	helper(text_win::err, "Error: ");

	va_list ap;
	va_start( ap, format );
	twp->vpr( format, ap, text_win::err );
	va_end( ap );

	helper(text_win::err, "\n");
}

void
err_and_warn::
i( const char *format, ... )
{
	helper(text_win::info, "Info: ");

	va_list ap;
	va_start( ap, format );
	twp->vpr( format, ap, text_win::info );
	va_end( ap );

	helper(text_win::info, "\n");
}

void
err_and_warn::
w( const char *format, ... )
{
	helper(text_win::warn, "Warning: ");

	va_list ap;
	va_start( ap, format );
	twp->vpr( format, ap, text_win::warn );
	va_end( ap );

	helper(text_win::warn, "\n");
}

// Authors: Ben Denckla, Patrick Pelletier
