#include "NotePairScoreElement.h"
#include "sched.h"
#include "MIDIsvc.h"

void NotePairScoreElement::
play(NotePairScoreScale s, ScheduleTime tt, Rogus_McBogus* r) const
{
	r->o.write(&msg);
	if (dur != -1)
	{
		MIDI_msg m = msg;
		switch(m.msgt())
		{
		case MidiMsg::note_on:
			m.set_vel(0);
			break;
		case MidiMsg::control_chn:
			m.d2 ^= 0x7f;
			break;
		default:
			r->ew.w("something which is not a note has duration - invalid!");
			break;
		}
		ScheduleTime t = tt + ScheduleTime(dur * s);
		task_data td(m, t);
		r->s.insert(td);
	}
}

// Author: Patrick Pelletier
