/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef TEXT_WIN_H
#define TEXT_WIN_H

#include <stdarg.h>
#include "basic_types.h"
#include "Rogus.h"
#include "WrappedCS.h"

class text_win
{
public:
	enum { bufsize = 128, numunits = 32 }; // has to be public or unit can't see it
  	enum msgt { info, warn, err };

   typedef void outfn(const char*, msgt);

private:
	struct unit {
		msgt msg_type;
		int len;
		char buf[bufsize];
	};
	unit units[numunits];
	int pos;
	int len;
//	friend class err_and_warn;
	char buf[2048];
	outfn* outfunc;
	static void my_outfunc(const char*, msgt);
	Bool inited;
	WrappedCS cs;
	HANDLE threadHandle;
	HANDLE eventHandle;
	Bool running;
	static unsigned WINAPI threadMain(LPVOID lpvThreadParm);
public:
	 text_win() { inited = False; }
	~text_win();
	void init(outfn*);
	
	void   pr( const char *format, ... );
	void  vpr( const char *format, va_list arg, msgt );
};

#endif
// Authors: Ben Denckla, Pete Rice, Patrick Pelletier
